Imports System.Attribute

Module CustomAttributes

    <AttributeUsage(AttributeTargets.Class)> _
    Class CustomAttribute
        Inherits System.Attribute

        'Declare two private fields to store the property values.
        Private msg As String

        'The Sub New constructor is the only way to set the properties.
        Public Sub New(ByVal _message As String)
            msg = _message
        End Sub

        Public Overridable ReadOnly Property Message() As String
            Get
                Return msg
            End Get
        End Property
    End Class

    ' Apply the custom attribute to this class.
    <Custom("Hello World!")> _
    Class MessageClass
        ' Message
        Private msg As String
        Sub New()
            Dim Attr As Attribute
            Dim CustAttr As CustomAttribute
            Attr = GetCustomAttribute(GetType(MessageClass), _
                                      GetType(CustomAttribute), False)
            CustAttr = CType(Attr, CustomAttribute)
            If CustAttr Is Nothing Then
                msg = "The attribute was not found."
            Else
                'Get the label and value from the custom attribute.
                msg = "The attribute label is: " & CustAttr.Message
            End If
        End Sub
        Sub Message()
            Console.WriteLine(msg)
        End Sub
    End Class

    Sub Main()
        Dim m As New MessageClass()
        m.Message()
    End Sub

End Module
