//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;

namespace CLRUnleashed
{
	public struct Point
	{
		// An event that clients can use to be notified whenever the
		// elements of the list change:
		private int x;
		private int y;
		public Point(int x, int y)
		{
			this.x = x;
			this.y = y;
		}
		public int X
		{
			get
			{
				return x;
			}
			set
			{
				x = value;
			}
		}
		public int Y
		{
			get
			{
				return y;
			}
			set
			{
				y = value;
			}
		}
		public Point Coordinate
		{
			get
			{
				return this;
			}
			set
			{
				x = value.x;
				y = value.y;
			}
		}
	}
	/// <summary>
	/// Summary description for Properties.
	/// </summary>
	class Properties
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			Point p = new Point(1, 2);
			Console.WriteLine("X: {0} Y: {1}", p.X, p.Y);
		}
	}
}
