//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;

namespace CLRUnleashed
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class G 
	{
		public int i;
		public G next;
	}
	class Unsafe
	{
		unsafe static void UnsafePointers() 
		{
			// pG is a whole object pointer
			G pG = new G();
			// ipi is an interior pointer
			fixed(int* ipi = &(pG.i))
			{
				*ipi = 10;
			}
			// ppG is an interior pointer
			G ppG = pG.next;
			// *ppG is a whole object pointer
			pG.next = new G();
		}

		unsafe static void StringAddress(string s)
		{
			fixed(char *p = s)
			{
				Console.WriteLine("0x{0:X8}", (uint)p);
			}       
		}
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			StringAddress("What is the address of this string?");
			UnsafePointers();
		}
	}
}
