//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;

using System.Collections;
using System.Threading;

namespace CLRUnleashed
{

	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class ValuesAndReferences
	{
		private static void StaticStringModifier(string s)
		{
			s = "that";
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			float a = 1.0F;
			float b = 1.0F;
			Console.WriteLine("a == b -> {0} ({1})", a == b, a.GetType());

			object ao;
			object bo;
			ao = a;
			bo = b;
			Console.WriteLine("a object == b object -> {0} {1} ({2})", ao.Equals(bo), ao == bo, ao.GetType().BaseType);

			string astr = "this";
			string bstr = "this";
			Console.WriteLine("a string == b string-> {0} ({1})", astr == bstr, astr.GetType().BaseType);

			Console.WriteLine("Before: {0}", astr);
			StaticStringModifier(astr);
			Console.WriteLine("After: {0}", astr);
		}
	}
}
